# getting started

1. fork git repository
1. git clone your fork
1. install npm packages `npm install`
1. testing:
   - unit ([jest](https://jestjs.io/)): `npm run test`
   - lint ([eslint](https://eslint.org/)): `npm run lint`
1. create merge request from your fork

# tasks

> * Check [examples.js](./examples.js) for code usage examples
> * Tasks can be made in any order

 * <2p> make each task as a separate commit(s), use meaningful commit messages
    - one task can be multiple commits
    - but one commit should not be more than one task
 * <1p> list tasks in merge request body, each task in separate line with commit(s) sha1 (if any commits)
    - example:
       - [x] short description of task, commit-sha1
       - [x] some more fix that is done, 97273b2
       - [ ] and one more bug fix
 * <1p> fix linting errors and do not make new errors in future
 * <1p> add git hook to run linter locally each time you commit new code (you can use [husky](https://www.npmjs.com/package/husky) or any tool you like)
 * <1p> update code style rules in this project:
    - use 4 spaces for indent
    - use `'` instead of `"`
 * <4p> add project ci pipeline, it should use node version `12` and check 3 things:
    - dependencies install
    - linter
    - unit testing
 * <2p> test `src/datestring.js` with mocking `src/unixtime.js`
    - check from mock that `ms` params set to seconds
    - use few differnet [date formats](https://momentjs.com/docs/#/displaying/format/)
 * <2p> use snapshot testing to test `src/company.js` (use ids 3, 85)
 * <1p> use string as input(id) for `src/company.js` - test that exception is given
 * <2p> write implementation (`lowercase.js`) for this test
```js
// src/lowercase.spec.js
const lowercase = require('./lowercase');

describe('lowercase', () => {
  it('CAT => cat', () => {
    expect(lowercase('CAT')).toBe("cat");
  });
  it('error - bad input', () => {
    expect(() => {
      lowercase({ "word": 'cat' });
    }).toThrow(/bad input/);
  });
});
```
 * <3p> make any random improvements
    - **NB:** this task is optional
    - you can make max 2 improvements, first 1p and second 2p, but they have to be in separate files and commits
